#include <windows.h>
#include <windowsx.h>
#include <stdio.h>

#define BUTTON_ID1 0
#define BUTTON_ID2 1

HMODULE hModule;
void (__stdcall *SetHook)(HINSTANCE hModule);
void (__stdcall *RemoveHook)();

LRESULT CALLBACK WndProc(HWND hWnd, UINT msg, WPARAM wParam, LPARAM lParam)
{
    HDC hdc;
    PAINTSTRUCT ps;
    static HWND hStartButton;
    static HWND hEndButton;

    switch(msg) {
    case WM_DESTROY:
        PostQuitMessage(0);
        return 1;

    case WM_COMMAND:
        switch(LOWORD(wParam)) {
            case BUTTON_ID1: 
                SetHook(hModule);
                break;
                
            case BUTTON_ID2:
                RemoveHook();
                break;
        }
        break;

    case WM_CREATE:
        hStartButton = CreateWindow(
                    TEXT("BUTTON"), TEXT("Start"),
                    WS_CHILD | WS_VISIBLE |BS_PUSHBUTTON,
                    0, 0, 100, 50, hWnd, (HMENU)BUTTON_ID1,
                    ((LPCREATESTRUCT)(lParam))->hInstance, NULL);
        hEndButton = CreateWindow(
                    TEXT("BUTTON"), TEXT("End"),
                    WS_CHILD | WS_VISIBLE |BS_PUSHBUTTON,
                    100, 0, 100, 50, hWnd, (HMENU)BUTTON_ID2,
                    ((LPCREATESTRUCT)(lParam))->hInstance, NULL);
    }
    return DefWindowProc(hWnd, msg, wParam, lParam);
}

int WINAPI WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance,
            PSTR lpCmdLine, int nCmdShow)
{
    hModule = LoadLibrary("mousehook_lib.dll");
    if(hModule == NULL) {
        fprintf(stderr, "not found mousehook_lib.dll");
        exit(1);
    }

    SetHook = (void (__stdcall *)(HINSTANCE)) (HINSTANCE)GetProcAddress(hModule, "SetHook");
    RemoveHook = (void (__stdcall *)()) (HINSTANCE)GetProcAddress(hModule, "RemoveHook");

    HWND hWnd;
    MSG msg;
    WNDCLASS winc;

    winc.style = CS_HREDRAW | CS_VREDRAW;
    winc.lpfnWndProc = WndProc;
    winc.cbClsExtra = winc.cbWndExtra = 0;
    winc.hInstance = hInstance;
    winc.hIcon = LoadIcon(NULL, IDI_APPLICATION);
    winc.hCursor = LoadCursor(NULL, IDC_ARROW);
    winc.hbrBackground = (HBRUSH)GetStockObject(WHITE_BRUSH);
    winc.lpszMenuName = NULL;
    winc.lpszClassName = TEXT("mousehook");

    if(!RegisterClass(&winc)) {
        fprintf(stderr, "RegisterClass\n");
        return 1;
    }

    hWnd = CreateWindow(
        TEXT("mousehook"), TEXT("Kitty on your lap"),
        WS_OVERLAPPEDWINDOW | WS_VISIBLE,
        CW_USEDEFAULT, CW_USEDEFAULT,
        300, 300,
        NULL, NULL, hInstance, NULL);

    if(hWnd == NULL) {
        fprintf(stderr, "CreateWindow\n");
        return 1;
    }

    while(GetMessage(&msg, NULL, 0, 0)) {
        TranslateMessage(&msg);
        DispatchMessage(&msg);
    }

    return msg.wParam;
}
