#include <windows.h>
#include <stdio.h>
#include <stdlib.h>

static HHOOK hMyHook = NULL;

HINSTANCE hInstance;

BOOL WINAPI DllMain(HINSTANCE hInst, DWORD fdwReason, LPVOID lpvReserved)
{
    if(fdwReason == DLL_PROCESS_ATTACH) {
        hInstance = hInst;
    }

    return TRUE;
}

LRESULT CALLBACK MouseProc(int nCode, WPARAM wParam, LPARAM lParam)
{
    if(nCode < 0) {
        return CallNextHookEx(hMyHook, nCode, wParam, lParam);
    }
    else if(nCode == HC_ACTION) {
        if(wParam == WM_LBUTTONDOWN) {
            LPMOUSEHOOKSTRUCT lpMouseStruct = (LPMOUSEHOOKSTRUCT)lParam;

            printf("clicked(left) x %d y %d\n", lpMouseStruct->pt.x, lpMouseStruct->pt.y);
            return CallNextHookEx(hMyHook, nCode, wParam, lParam);
        }
        else if(wParam == WM_RBUTTONDOWN) {
            LPMOUSEHOOKSTRUCT lpMouseStruct = (LPMOUSEHOOKSTRUCT)lParam;

            printf("clicked(right) x %d y %d\n", lpMouseStruct->pt.x, lpMouseStruct->pt.y);
            return CallNextHookEx(hMyHook, nCode, wParam, lParam);
        }
        else if(wParam == WM_MOUSEMOVE) {
            LPMOUSEHOOKSTRUCT lpMouseStruct = (LPMOUSEHOOKSTRUCT)lParam;

            printf("moving x %d y %d\n", lpMouseStruct->pt.x, lpMouseStruct->pt.y);
            return CallNextHookEx(hMyHook, nCode, wParam, lParam);
        }
        else {
            return CallNextHookEx(hMyHook, nCode, wParam, lParam);
        }
    }
    else {
        return CallNextHookEx(hMyHook, nCode, wParam, lParam);
    }
}

__declspec(dllexport) __stdcall void SetHook(HINSTANCE hModule)
{
    hMyHook = SetWindowsHookEx(WH_MOUSE_LL
        , MouseProc
        , hModule 
        , 0); 

    if(hMyHook == NULL) 
    {
        LPVOID lpMsgBuf;
        FormatMessage(FORMAT_MESSAGE_ALLOCATE_BUFFER|FORMAT_MESSAGE_FROM_SYSTEM | FORMAT_MESSAGE_IGNORE_INSERTS, NULL, GetLastError(), MAKELANGID(LANG_NEUTRAL, SUBLANG_DEFAULT), (LPSTR)&lpMsgBuf, 0, NULL);
        printf("%s", lpMsgBuf);
        LocalFree(lpMsgBuf);
        exit(0);
    }
}

__declspec(dllexport) __stdcall void RemoveHook()
{
    if(hMyHook) {
        (void)UnhookWindowsHookEx(hMyHook);
        hMyHook = NULL;
    }
}

